-- freeslots & states go here to keep scripts clean
-- RUN
freeslot("SPR_SINR")
for i = 1, 6
	freeslot("S_SILVRUN_"..i)
end

function A_SilvRun(actor)		-- this action sets our tics
	if not actor.player return end
	if actor.player.speed > 53*actor.scale
		actor.tics = 1
	else
		actor.tics = 2
	end
end

states[S_SILVRUN_1] = {SPR_SINR, A, 2, A_SilvRun , 0, 0, S_SILVRUN_2}
states[S_SILVRUN_2] = {SPR_SINR, B, 2, A_SilvRun , 0, 0, S_SILVRUN_3}
states[S_SILVRUN_3] = {SPR_SINR, C, 2, A_SilvRun , 0, 0, S_SILVRUN_4}
states[S_SILVRUN_4] = {SPR_SINR, D, 2, A_SilvRun , 0, 0, S_SILVRUN_5}
states[S_SILVRUN_5] = {SPR_SINR, E, 2, A_SilvRun , 0, 0, S_SILVRUN_6}
states[S_SILVRUN_6] = {SPR_SINR, F, 2, A_SilvRun , 0, 0, S_SILVRUN_1}

-- FLOAT
freeslot("sfx_float", "sfx_cancel", "SPR_SLEV", "S_SILVFLOAT", "SPR_LEVL", "SPR_OVOL")
states[S_SILVFLOAT] = {SPR_SLEV, A, -1,nil , 0, 0, S_SILVFLOAT}

-- CUT
freeslot("MT_PSYCHOCUT", "SPR_PSCT", "sfx_pscut")
freeslot("S_PSYCUT", "S_PSYCUT2")
mobjinfo[MT_PSYCHOCUT] = {
	-1,
	S_PSYCUT,
	1,
	S_NULL,
	sfx_None,
	0,
	sfx_None,
	S_NULL,
	0,
	sfx_None,
	S_NULL,
	S_NULL,
	S_NULL,
	S_NULL,
	sfx_None,
	6,
	32 * FRACUNIT,
	64 * FRACUNIT,
	0,
	100,
	0,
	sfx_None,
	MF_NOGRAVITY|MF_NOCLIPHEIGHT|MF_NOCLIPHEIGHT|MF_NOCLIP,
	S_NULL
}
mobjinfo[MT_PSYCHOCUT].speed = FRACUNIT*45
mobjinfo[MT_PSYCHOCUT].painchance = 192*FRACUNIT

addHook("MobjThinker", function(mo)
	if mo and mo.valid
		if mo.color2 then mo.color = leveltime%4 >= 2 and mo.color2 or SKINCOLOR_TEAL end
	end
end, MT_PSYCHOCUT)


function A_PsycutWallcheck(mo)
	if mo and mo.valid
		local c = P_SpawnMobj(mo.x, mo.y, mo.z, MT_PSYCHOCUT)
		mo.angle = R_PointToAngle2(mo.x, mo.y, mo.x+mo.momx, mo.y+mo.momy)
		c.state = S_INVISIBLE
		c.weapon = mo.weapon
		c.tics = 1
		c.height = mo.height
		c.radius = mo.radius
		c.flags = $ & ~MF_NOCLIP
		c.target = mo.target
		local g = P_SpawnGhostMobj(mo)
		if silv_blockingWall(mo) and not (mo.flags & MF_BOUNCE)
			if mo and mo.explode
				mo.flags = MF_MISSILE|MF_NOGRAVITY
				A_RingExplode(mo)
				local a = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
				a.state = S_INVISIBLE
				a.tics = TICRATE
				S_StartSound(a, sfx_pop)
			end
			P_RemoveMobj(mo)
		end
	end
end

states[S_PSYCUT] = {SPR_PSCT, A|FF_FULLBRIGHT, 1,A_PsycutWallcheck , 0, 0, S_PSYCUT}
states[S_PSYCUT2] = {SPR_PSCT, B|FF_FULLBRIGHT, 1,A_PsycutWallcheck , 0, 0, S_PSYCUT2}

-- TELEKINESIS
freeslot("MT_PSYHITBOX", "S_SILVTHROW")
mobjinfo[MT_PSYHITBOX] = {
	-1,
	S_INVISIBLE,
	1,
	S_NULL,
	sfx_None,
	0,
	sfx_None,
	S_NULL,
	0,
	sfx_None,
	S_NULL,
	S_NULL,
	S_NULL,
	S_NULL,
	sfx_None,
	6,
	64 * FRACUNIT,
	64 * FRACUNIT,
	0,
	100,
	0,
	sfx_None,
	MF_NOGRAVITY|MF_NOCLIPHEIGHT|MF_NOBLOCKMAP,
	S_NULL
}

function A_SilvCopyState(actor)	-- copy a mobj's spawnstate so that Silver can throw objects that overwrite movement (like buzzes)
	actor.sprite = states[mobjinfo[actor.type].spawnstate].sprite
	actor.frame = states[mobjinfo[actor.type].spawnstate].frame
end
states[S_SILVTHROW] = {SPR_NULL, A, 1, A_SilvCopyState , 0, 0, S_SILVTHROW}

-- SUPER

function A_SuperSilvStandCheck(actor)
	if actor and actor.skin == "silver"
		if actor.player and actor.player.powers[pw_super] ~= 0
			actor.state = S_SUPERSILV_STAND1
		end

		if actor.slide
		and actor.player and actor.player.speed > 1
		and actor.resetstandframe == false
			actor.state = S_PLAY_PAIN
			actor.frame = o
		end
	end
end

function A_SuperSilverWFrame(actor)
	if actor.skin == "silver"
	and actor.player and actor.player.powers[pw_super]
		actor.state = S_SUPERSILV_WALK1
	end
end

function A_SuperSilvWalk(actor)
	if actor.player and actor.player.speed <= 10*actor.scale
		actor.tics = 4
	else
		actor.tics = 2
	end
end

function A_SuperSilverSpring(actor)
	if not (actor.eflags & MFE_VERTICALFLIP)
		if actor.momz < 0
			actor.state = S_SUPERSILV_FALL1
		end
	else
		if actor.momz > 0
			actor.state = S_SUPERSILV_FALL1
		end
	end
end

function A_SuperSilverGlow(actor)
	if actor.skin == "silver"
	and actor.player and actor.player.powers[pw_super] ~= 0
		actor.frame = $1 | FF_FULLBRIGHT
	end
end

function A_SuperSilvGasp(actor)
	if actor.skin == "silver"
	and actor.player and actor.player.powers[pw_super] ~= 0
		actor.state = S_SUPERSILV_GASP
	end
end

states[S_PLAY_STND].action = A_SuperSilvStandCheck
states[S_PLAY_TAP1].action = A_SilverBoredom
states[S_PLAY_TAP2].action = A_SilverBoredom
states[S_PLAY_ATK1].action = A_SuperSilverGlow
states[S_PLAY_ATK2].action = A_SuperSilverGlow
states[S_PLAY_ATK3].action = A_SuperSilverGlow
states[S_PLAY_ATK4].action = A_SuperSilverGlow
states[S_PLAY_RUN1].action = A_SuperSilverWFrame
states[S_PLAY_SUPERTRANS3].action = A_SuperSilverGlow
states[S_PLAY_SUPERTRANS4].action = A_SuperSilverGlow
states[S_PLAY_SUPERTRANS5].action = A_SuperSilverGlow
states[S_PLAY_SUPERTRANS6].action = A_SuperSilverGlow
states[S_PLAY_SUPERTRANS7].action = A_SuperSilverGlow
states[S_PLAY_SUPERTRANS8].action = A_SuperSilverGlow
states[S_PLAY_SUPERTRANS9].action = A_SuperSilverGlow
states[S_PLAY_SUPERFLY1].action = A_SuperSilverGlow
states[S_PLAY_SUPERFLY2].action = A_SuperSilverGlow
states[S_PLAY_GASP].action = A_SuperSilverGasp

freeslot("SPR_SSIN", "S_SUPERSILV_STAND1", "S_SUPERSILV_STAND2", "S_SUPERSILV_STAND3", "S_SUPERSILV_STAND4", "S_SUPERSILV_FWALK1", "S_SUPERSILV_FWALK2", "S_SUPERSILV_FWALK3", "S_SUPERSILV_FWALK4",
"S_SUPERSILV_WALK1", "S_SUPERSILV_WALK2", "S_SUPERSILV_WALK3", "S_SUPERSILV_WALK4", "S_SUPERSILV_WALK5", "S_SUPERSILV_WALK6", "S_SUPERSILV_WALK7", "S_SUPERSILV_WALK8",
"S_SUPERSILV_SPRING", "S_SUPERSILV_FALL1", "S_SUPERSILV_FALL2", "S_SUPERSILV_HANG", "S_SUPERSILV_GASP")

-- STAND
states[S_SUPERSILV_STAND1] = {SPR_SSIN, FF_FULLBRIGHT|A, 5, nil, 0, 0, S_SUPERSILV_STAND2}
states[S_SUPERSILV_STAND2] = {SPR_SSIN, FF_FULLBRIGHT|B, 5, nil, 0, 0, S_SUPERSILV_STAND3}
states[S_SUPERSILV_STAND3] = {SPR_SSIN, FF_FULLBRIGHT|C, 5, nil, 0, 0, S_SUPERSILV_STAND4}
states[S_SUPERSILV_STAND4] = {SPR_SSIN, FF_FULLBRIGHT|B, 5, nil, 0, 0, S_SUPERSILV_STAND1}

-- FLOAT/FLOATWALK

states[S_SUPERSILV_FWALK1] = {SPR_SSIN, FF_FULLBRIGHT|D, 5, nil, 0, 0, S_SUPERSILV_FWALK2}
states[S_SUPERSILV_FWALK2] = {SPR_SSIN, FF_FULLBRIGHT|E, 5, nil, 0, 0, S_SUPERSILV_FWALK3}
states[S_SUPERSILV_FWALK3] = {SPR_SSIN, FF_FULLBRIGHT|F, 5, nil, 0, 0, S_SUPERSILV_FWALK4}
states[S_SUPERSILV_FWALK4] = {SPR_SSIN, FF_FULLBRIGHT|E, 5, nil, 0, 0, S_SUPERSILV_FWALK1}

-- WALK

states[S_SUPERSILV_WALK1] = {SPR_SSIN, FF_FULLBRIGHT|G, 4, A_SuperSilvWalk, 0, 0, S_SUPERSILV_WALK2}
states[S_SUPERSILV_WALK2] = {SPR_SSIN, FF_FULLBRIGHT|H, 4, A_SuperSilvWalk, 0, 0, S_SUPERSILV_WALK3}
states[S_SUPERSILV_WALK3] = {SPR_SSIN, FF_FULLBRIGHT|I, 4, A_SuperSilvWalk, 0, 0, S_SUPERSILV_WALK4}
states[S_SUPERSILV_WALK4] = {SPR_SSIN, FF_FULLBRIGHT|J, 4, A_SuperSilvWalk, 0, 0, S_SUPERSILV_WALK5}
states[S_SUPERSILV_WALK5] = {SPR_SSIN, FF_FULLBRIGHT|K, 4, A_SuperSilvWalk, 0, 0, S_SUPERSILV_WALK6}
states[S_SUPERSILV_WALK6] = {SPR_SSIN, FF_FULLBRIGHT|L, 4, A_SuperSilvWalk, 0, 0, S_SUPERSILV_WALK7}
states[S_SUPERSILV_WALK7] = {SPR_SSIN, FF_FULLBRIGHT|M, 4, A_SuperSilvWalk, 0, 0, S_SUPERSILV_WALK8}
states[S_SUPERSILV_WALK8] = {SPR_SSIN, FF_FULLBRIGHT|N, 4, A_SuperSilvWalk, 0, 0, S_SUPERSILV_WALK1}

-- SPRING

states[S_SUPERSILV_SPRING] = {SPR_SSIN, FF_FULLBRIGHT|Q, 1, A_SuperSilverSpring, 0, 0, S_SUPERSILV_SPRING}
states[S_SUPERSILV_FALL1] = {SPR_SSIN, FF_FULLBRIGHT|R, 4, nil, 0, 0, S_SUPERSILV_FALL2}
states[S_SUPERSILV_FALL2] = {SPR_SSIN, FF_FULLBRIGHT|S, 4, nil, 0, 0, S_SUPERSILV_FALL1}

-- SAYORI

states[S_SUPERSILV_HANG] = {SPR_SSIN, FF_FULLBRIGHT|P, -1}

-- GASP

states[S_SUPERSILV_GASP] = {SPR_SSIN, FF_FULLBRIGHT|O, 10, nil, 0, 0, S_SUPERSILV_FWALK1}