-- Literally the bane of my existence

local MAX_TELEKINESIS_RANGE = FRACUNIT*768
local telekinesis_table = {}

local lp
local camchase
hud.add(function(v, p, c)
	camchase = c.chase
	lp = p
end)

rawset(_G, "isvolley", function()
	return mapheaderinfo[gamemap].silvervolley
end)

rawset(_G, "silv_getTKtable", function()
	return telekinesis_table
end)

rawset(_G, "silv_blockingWall", function(mobj)

	mobj.tester = P_SpawnMobj(mobj.x, mobj.y, mobj.z, MT_GARGOYLE) -- Has the best chance of not getting cleared on spawn
	local tester = mobj.tester
	tester.flags = MF_NOGRAVITY|MF_NOCLIPTHING -- Make sure it won't move or block things
	tester.state = S_INVISIBLE -- make sure it fucks off afterwards
	tester.tics = 1

    tester.radius = mobj.radius
    tester.height = mobj.height
	-- special case...
	if mobj.type == MT_PSYCHOCUT
	and mobj.target and mobj.target.valid
		tester.radius = mobj.target.radius
		tester.height = mobj.target.height
	end
	local angle = R_PointToAngle2(mobj.x, mobj.y, mobj.x+mobj.momx, mobj.y+mobj.momy)
    tester.angle = angle

	local maxdist = FixedHypot(mobj.momx, mobj.momy)
    P_InstaThrust(tester, angle, maxdist) -- Misuse P_InstaThrust to easily get the distance to move
    return not P_TryMove(tester, tester.momx+mobj.x, tester.momy+mobj.y, true) -- Return the inverse of P_TryMove (since it returns true on successful move, false on blocked)
end)

rawset(_G, "silv_setUseDelay", function(mo, t)
	if tonumber(t) == nil return end
	mo.silv_pusedelay, mo.silv_usedelay = t, t
end)

local function silv_resetObject(mo)		-- resets an object for further Telekinesis use
	if mo and mo.valid and mo.health else return end
	mo.silv_grabbed = nil
	--mo.silv_grab = nil
	mo.state = mobjinfo[mo.type].spawnstate
	mo.flags = mobjinfo[mo.type].flags
	if mo.player	-- REEE
		local p = mo.player
		local skin = skins[mo.skin]
		p.normalspeed = skin.normalspeed
		p.jumpfactor = skin.jumpfactor
		if not P_IsObjectOnGround(mo)
			mo.state = S_PLAY_FALL1
		end
		p.silv_grabbed = nil
	end
end

freeslot("sfx_ovrchr")
local function silv_fillGauge(p, amount)
	if p and p.mo and p.mo.valid and not p.powers[pw_super]
		amount = $ or 1
		local mo = p.mo
		mo.silv_energy = $+amount
		if mo.silv_energy >= SILVER_MAX_ENERGY
			mo.silv_boostenergy = TICRATE*4
			mo.silv_energy = SILVER_MAX_ENERGY
			S_StartSound(nil, sfx_ovrchr, p)
		end
	end
end

rawset(_G, "friendlyPlayer", function(p1, p2)						-- check 2 players. Returns true if the player is friendly, false else.

	if p1 and p2 and p1.valid and p2.valid

	-- is our player a friend to the other?

		if gametype == GT_COOP		-- Are we on coop?
		or G_PlatformGametype()		-- Race will count because else it's REALLY unfair.
		--and not cv_psynarchy.value

		or (gametype == GT_TEAMMATCH or gametype == GT_CTF)
		and p1.ctfteam == p2.ctfteam						-- Are we on a team gametype with both players on the same team?
		--and not cv_psynarchy.value

		or G_TagGametype()
		and ((p1.pflags & PF_TAGIT and p2.pflags & PF_TAGIT) or (not (p1.pflags & PF_TAGIT) and (not (p2.pflags & PF_TAGIT))))
		--and not cv_psynarchy.value
			return true								-- Then both players are friends! =D
		else
			return false							-- Then they're enemies! >:)
		end
	end
end)

local function tagGrab(p1, p2)
	if p1 and p2 and p1.valid and p2.valid
		if G_TagGametype()
		and (p1.pflags & PF_TAGIT and not (p2.pflags & PF_TAGIT) or (not (p1.pflags & PF_TAGIT)) and p2.pflags & PF_TAGIT)
			return false
		else
			return true
		end
	end
end

local function explodeTK(target)
	if not target or not target.valid return end
	for i=1,16
		local b = P_SpawnMobj(target.x, target.y, target.z+20*FRACUNIT, MT_THOK)
		b.momx = P_RandomRange(-15, 15)*FRACUNIT
		b.momy = P_RandomRange(-15, 15)*FRACUNIT
		b.momz = P_RandomRange(-15, 15)*FRACUNIT
		b.frame = A|FF_FULLBRIGHT|TR_TRANS50
		b.color = SKINCOLOR_TEAL
		b.scale = FRACUNIT/2
		b.destscale = FRACUNIT/12
	end
end

local function buildTelekinesistable()
	telekinesis_table = {}
	for mobj in thinkers.iterate("mobj")
		if mobj and (mobj.flags & (MF_ENEMY|MF_MONITOR|MF_MISSILE|MF_BOSS) or mobj.player)
			table.insert(telekinesis_table, mobj)
			if mobj.player and mobj.player.silv_grabbed -- I FUCKING TOLD YOU
				silv_resetObject(mobj)
			elseif mobj.flags & MF_MONITOR
			and mobj.silv_x == nil
				mobj.silv_x = mobj.x
				mobj.silv_y = mobj.y
				mobj.silv_z = mobj.z
			end
		end
	end
end

addHook("MapLoad", do
	-- set up Silver's telekinesis:
	buildTelekinesistable()
end)

addHook("NetVars", function(net)	-- NOW LOOK AT THIS NET
	telekinesis_table = net(telekinesis_table)	-- sync this table, it's kinda important
end)

local function silv_sortObjects(p, n, notv)	-- return the 4 closest objects to us...

	local mo = p.mo
	if not mo return {} end
	local t = telekinesis_table
	local dump = {}
	local mindist = FixedMul(mo.scale, MAX_TELEKINESIS_RANGE) / FRACUNIT
	local removekey = 0
	local add = t[1]

	if not t or not #t return {} end	-- NOPE

	--1: Spawn dummy object in front of us as a poor excuse of an hitbox
	local dist = mindist/2
	local x, y, z = mo.x + dist*cos(mo.angle), mo.y + dist*sin(mo.angle), mo.z
	local tcheck = P_SpawnMobj(x, y, z, MT_NULL)

	--2: Copy table (else it would affect the original table). Only put objects that are in range and can be grabbed in there
	for k,v in ipairs(t)
		if v and v.valid and R_PointToDist2(v.x, v.y, tcheck.x, tcheck.y) < FixedMul(MAX_TELEKINESIS_RANGE/2, mo.scale) and v ~= mo
		and not (mo.silv_grab == v)	-- lolno
		--and not (isvolley() and (mo.type ~= MT_PLAYER or mo.player))	-- cannot grab actual players in volley. But since the ball is a fake player...
		and abs(mo.z - v.z) < FixedMul((MAX_TELEKINESIS_RANGE/2), mo.scale)
		and v.health
		and P_CheckSight(mo, v)
		and not v.silv_grabbed	-- not already grabbed
		and not (notv and v.flags & (MF_MONITOR|MF_MISSILE))
		and not (p.bot and v.flags & MF_MONITOR)	-- bots cannot grab monitors
		and not (not (notv) and v.flags & MF_BOSS)	-- only target bosses when we're throwing
		and not (v.floorz >= mo.ceilingz)
		and not (v.ceilingz <= mo.floorz)
		and not (v.flags & (MF_ENEMY|MF_BOSS) and not (v.flags & MF_SHOOTABLE))
		and not (v.player and friendlyPlayer(p, v.player))
		and not (v.player and not (tagGrab(p, v.player)))
		and not (v.player and (v.player.powers[pw_flashing] or v.player.powers[pw_invulnerability]))
		-- special cases
		and not (G_GametypeHasTeams() and (v.type == MT_BLUERINGBOX and p.ctfteam ~= 2 or v.type == MT_REDRINGBOX and p.ctfteam ~= 1))
		--or isvolley() and (not v.player) and v.type == MT_PLAYER and v ~= mo and not v.silv_grabbed
			table.insert(dump, v)
		end
	end

	if not #dump then return {} end

	--3: out of what we have, check for walls inbetween...
	local i = #dump
	while i
		local v = dump[i]
		local an = R_PointToAngle2(mo.x, mo.y, v.x, v.y)
		local dist = R_PointToDist2(mo.x, mo.y, v.x, v.y) / FRACUNIT
		for d = 0, 7
			local tdist = (dist / 8) + (dist / 8)*(d-1)
			local x, y = mo.x + tdist*cos(an), mo.y + tdist*sin(an)
			local z = R_PointInSubsector(x, y).sector.floorheight
			if z < v.z then z = v.z end
			if z < R_PointInSubsector(x, y).sector.floorheight then z = R_PointInSubsector(x, y).sector.floorheight end	-- this is to fix issues with slopes
			local test = P_SpawnMobj(x, y, z, MT_GARGOYLE)	-- spawn a gargoyle
			test.flags = MF_NOCLIPTHING|MF_NOGRAVITY		-- let's not crush ourselves
			test.radius = FRACUNIT/2
			test.height = FRACUNIT	-- let's be lenient
			test.state = S_INVISIBLE
			test.tics = 1
			if not P_TryMove(test, mo.x + (tdist + dist/8)*cos(an), mo.y + (tdist + dist/8)*sin(an))	-- yeah that's fucking hacky
				table.remove(dump, i)
				break
			end
		end
		i = $-1
	end

	if #dump < n then n = #dump end

	--4: scream in panic
	local enemies = {}
	repeat
		for i = 1, #dump do
			local v = dump[i]
			if not (v or v.valid) continue end
			local dist = R_PointToDist2(v.x, v.y, tcheck.x, tcheck.y) / FRACUNIT -- gross simplification
			if dist < mindist
				mindist = dist
				add = v
				removekey = i
			end
		end

		if add
			enemies[#enemies+1] = add
			table.remove(dump, removekey)
			mindist = FixedMul(mo.scale, MAX_TELEKINESIS_RANGE) / FRACUNIT
			removekey = 0
			add = nil
		end
	until #enemies >= n
	return enemies
end

local function silv_droptelekinesis(p, i)
	local mo = p.mo
	if not mo return end
	if not mo.silv_telekinesis return end
	if not #mo.silv_telekinesis return end

	local k = #mo.silv_telekinesis
	while k
		if i and i ~= k
			k = $-1
			continue
		end
		local v = mo.silv_telekinesis[k]
		if v and v.valid
			if mobjinfo[v.type].flags & MF_MISSILE	-- kill missiles, else they're gonna stay here floating about for no reason lmao
				v.target = mo	-- make the missile belong to us so that if it's an explosion / grenade ring, it can hurt players and award us points
				v.flags = $|MF_MISSILE	-- give it back its flag
				P_KillMobj(v)
			else
				silv_resetObject(v)
			end
		end
		table.remove(mo.silv_telekinesis, k)
		k = $-1
	end
end

-- push object
local function silv_push(p, obj)
	if not p.mo return end
	if not obj return end
	-- special case for players:
	if obj.type == MT_PLAYER
	and obj.player
		P_DoPlayerPain(obj.player)
	end
	local mo = p.mo
	local pushangle = R_PointToAngle2(mo.x, mo.y, obj.x, obj.y)
	local pushforce = FRACUNIT*48 - (R_PointToDist2(mo.x, mo.y, obj.x, obj.y) / 16)
	P_InstaThrust(obj, pushangle, pushforce)
	P_SetObjectMomZ(obj, FRACUNIT*5)
end

-- push nearby enemies / the ball. Only for thokker.
local function silv_thokkerpush(p)
	local mo = p.mo
	if not mo return end
	-- show radius
	for i = 1, 16
		local thok = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
		thok.color = SKINCOLOR_TEAL
		thok.angle = $+ ((ANG1*45)/2)*(i-1)
		thok.tics = 10
		thok.scale = mo.scale
		thok.destscale = mo.scale/10
		thok.scalespeed = FRACUNIT/10
		P_InstaThrust(thok, thok.angle, 79*FRACUNIT)
	end
	S_StartSound(mo, sfx_s3k83)

	-- push players:
	for player in players.iterate do
		if player.mo and player.ctfteam ~= p.ctfteam and R_PointToDist2(mo.x, mo.y, player.mo.x, player.mo.y) < mo.scale*768 and abs(player.mo.z - mo.z) < FRACUNIT*256
			silv_push(p, player.mo)
		end
	end

	-- push ball
	for obj in thinkers.iterate("mobj")
		if obj and obj.valid and obj.type == MT_BIGTUMBLEWEED
		and R_PointToDist2(mo.x, mo.y, obj.x, obj.y) < mo.scale*768 and abs(obj.z - mo.z) < FRACUNIT*256
			silv_push(p, obj)
		end
	end

end

-- Snu, you better draw me some yuri for this..........
local function silv_handleTKselection(p)
	if not p return end
	local mo = p.mo

	if mo.silv_selection == nil
		mo.silv_selection = 0
		mo.silv_selectiontimer = 0
	end

	if not mo.silv_telekinesis or #mo.silv_telekinesis < 2
		mo.silv_selection = 0
	return end

	-- hacky timers we'll need, or something
	if p.cmd.buttons & BT_WEAPONNEXT
		mo.silv_nextt = mo.silv_nextt and $+1 or 1
	else
		mo.silv_nextt = 0
	end
	if p.cmd.buttons & BT_WEAPONPREV
		mo.silv_prevt = mo.silv_prevt and $+1 or 1
	else
		mo.silv_prevt = 0
	end

	if mo.silv_nextt == 1
		mo.silv_selection = $+1
		if mo.silv_selection > #mo.silv_telekinesis
			mo.silv_selection = 0
		end
		S_StartSound(mo, sfx_s3k7e, mo.player)
		mo.silv_selectiontimer = 0
	elseif mo.silv_prevt == 1
		mo.silv_selection = $-1
		if mo.silv_selection < 0
			mo.silv_selection = #mo.silv_telekinesis
		end
		S_StartSound(mo, sfx_s3k7e, mo.player)
		mo.silv_selectiontimer = 0
	end

	-- manage BT_WEAPONMASK
	if p.cmd.buttons & BT_WEAPONMASK
		mo.silv_maskt = mo.silv_maskt and $+1 or 1
	else
		mo.silv_maskt = 0
	end

	if mo.silv_maskt == 1
		mo.silv_selection = min(#mo.silv_telekinesis, (p.cmd.buttons & BT_WEAPONMASK) -1)
		mo.silv_selectiontimer = 0
		S_StartSound(mo, sfx_s3k7e, mo.player)
	end

	-- selection issues, under or over max values for WHATEVER reason
	mo.silv_selection = min($, #mo.silv_telekinesis)
	mo.silv_selection = max(0, $)

	mo.silv_selectiontimer = $+1
end

rawset(_G, "silv_handleTelekinesis", function(p)
	local mo = p.mo
	if not mo return end
	p.weapondelay = 5	-- Silver can't fire rings, ever.
	if p.charability ~= 69 return end

	if not mo.silv_telekinesis
		mo.silv_telekinesis = {}		-- objects we're holding	(up to 4)
		mo.silv_thrown = {}				-- all the shit we've thrown
	end

	-- Telekinesis selection
	silv_handleTKselection(p)

	-- tossflag hold:
	if p.cmd.buttons & BT_TOSSFLAG
		mo.silv_tossflag = mo.silv_tossflag ~= nil and $+1 or 1
	else
		mo.silv_tossflag = 0
	end

	-- Ability usage
	mo.silv_matchplus_telekinesis = nil		-- don't ask
	if (p.cmd.buttons & BT_USE)
	and not mo.silv_usedelay
	and not (p.pflags & (PF_SPINNING|PF_STARTDASH))
	and not p.exiting
	and not (p.powers[pw_nocontrol])
	and not p.gotflag
	and not mo.silv_sliding
		if not mo.silv_firehold
		and not (mo.silv_floatstate and mo.silv_floatstate <= 2)
		and not P_PlayerInPain(p) and not (p.powers[pw_flashing] and G_RingSlingerGametype())

			-- we playing thokker???
			if mapheaderinfo[gamemap].thokkerball and gametype == GT_TEAMMATCH
				if mo.silv_energy >= SILVER_MAX_ENERGY/4
					silv_thokkerpush(p)
					silv_setUseDelay(mo, TICRATE*2)
					mo.silv_energy = $ - SILVER_MAX_ENERGY/4
				end
				return
			end

			if not #mo.silv_telekinesis		-- it's safe to assume that we're not holding anything and seek to remedy to the problem :P

				mo.silv_matchplus_telekinesis = true
				if P_IsObjectOnGround(mo)	-- I guess let's follow Speedwagon's suggestion...
				and mo.silv_energy > SILVER_MAX_ENERGY/5
				and not mo.silv_grabbed	-- cannot grab if being grabbed. This avoids weird Telekinesis trains
					if silv_meme()
						S_StartSound(mo, sfx_thrw1)
					end
					silv_setUseDelay(mo, TICRATE)
					mo.silv_telekinesis = silv_sortObjects(p, (min(280, mo.silv_energy)/70))	-- pick up to 4 objs
					mo.silv_energy = $ - (70*#mo.silv_telekinesis)					-- bye energy

					-- show a radius?
					for i = 0, 15
						local thok = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
						thok.color = SKINCOLOR_TEAL
						thok.angle = (mo.angle - 80*ANG1) + i*ANG1*10
						thok.tics = 10
						thok.scale = mo.scale
						thok.destscale = mo.scale/10
						thok.scalespeed = FRACUNIT/10
						P_InstaThrust(thok, thok.angle, 79*FRACUNIT)
					end

					S_StartSound(mo, sfx_s3k74)
					-- ready some stuff with our newly grabbed objects...
					for k,v in ipairs(mo.silv_telekinesis)
						v.silv_grabbed = true	-- make sure we won't get grabbed by anything else
						v.flags = $|MF_SLIDEME	-- this helps
						v.flags = $ & ~MF_SOLID
						v.flags = $ & ~MF_SPECIAL
						if v.flags & MF_MONITOR
							v.flags = $ & ~MF_MONITOR
							v.flags = $ & ~MF_SHOOTABLE	-- don't destroy monitors
						end
						if v.flags & MF_MISSILE
							v.flags = $ & ~MF_MISSILE
							v.target = mo
							v.fuse = -1	-- stop item fuse
						end
						if v.player	-- oh no...
							silv_setUseDelay(mo, TICRATE*5/2)	-- ringslinger balance????
							v.player.normalspeed = 0; v.player.jumpfactor = 0; v.player.silv_grabbed = true	-- yes, you never know, the god damn map might be changed inbetween.
							v.player.pflags = $ & ~(PF_JUMPED|PF_GLIDING)
							v.player.glidetime = 0
							v.player.skidtime = 0
						end
					end
				end
			else	-- we're throwing that shit away

				local memeseed = P_RandomRange(0, 2)	-- generate even if we're not in meme mode to prevent desynch
				if silv_meme()
					S_StartSound(mo, sfx_thrw2+memeseed)
				end

				silv_setUseDelay(mo, TICRATE)
				mo.silv_throwcombo = 0
				S_StartSound(mo, sfx_s3k83)
				local targets = silv_sortObjects(p, mo.silv_selection or #mo.silv_telekinesis, true)
				if not #targets
					local k = #mo.silv_telekinesis
					while k
						local v = mo.silv_telekinesis[k]
						-- SELECTION CHECK
						if mo.silv_selection and k ~= mo.silv_selection
							k = $-1
							continue
						end
						-- just throw them
						table.insert(mo.silv_thrown, v)
						if v.flags & MF_ENEMY
							v.state = S_SILVTHROW
						end
						v.flags = mobjinfo[v.type].flags
						v.silv_grabbed = nil				-- we aren't being grabbed anymore, meaning silvers can retaliate against one another :P
						local speed = isvolley() and 24 or 64
						v.momx = FixedMul(mo.scale, speed * FixedMul(cos(mo.angle), cos(p.aiming)))
						v.momy = FixedMul(mo.scale, speed * FixedMul(sin(mo.angle), cos(p.aiming)))
						v.momz = FixedMul(mo.scale, (isvolley() and speed*3/2 or speed) * sin(p.aiming))
						table.remove(mo.silv_telekinesis, k)
						mo.silv_selectiontimer = 0
						k = $-1
					end
				else
					local k = #mo.silv_telekinesis
					while k
						local v = mo.silv_telekinesis[k]
						-- SELECTION CHECK
						if mo.silv_selection and k ~= mo.silv_selection
							k = $-1
							continue
						end
						-- set target
						local index = k
						if k > #targets then index = #targets end
						if v.flags & MF_ENEMY
						and v.flags & MF_NOGRAVITY
							v.state = S_SILVTHROW
						end
						v.flags = mobjinfo[v.type].flags
						v.silv_target = targets[index]		-- make that indepent from mobj.target which may be updated
						v.silv_chase = TICRATE
						table.insert(mo.silv_thrown, v)
						v.silv_grabbed = nil				-- we aren't being grabbed anymore, meaning silvers can retaliate against one another :P
						table.remove(mo.silv_telekinesis, k)
						mo.silv_selectiontimer = 0
						k = $-1
					end
				end
			end
			mo.silv_firehold = true
		end
	elseif mo.silv_tossflag == 1
	or p.gotflag
		silv_droptelekinesis(p, not p.gotflag and mo.silv_selection or 0)
	else
		mo.silv_firehold = nil
	end

	-- Manage our tables...
	-- Manage our held objects...
	-- Iterate backwards, you never know when an object is to disappear
	if mo.silv_telekinesis and #mo.silv_telekinesis

		p.pflags = $|PF_WPNDOWN

		if not mo.silv_boostenergy
		and not p.powers[pw_super]
			silv_floatTrail(mo, true)
		end

		local k = #mo.silv_telekinesis
		local i = 1

		local twod = (mo.flags2 & MF2_TWOD or mapheaderinfo[gamemap].typeoflevel & TOL_2D)
		local baseangle = (mo.angle + (ANGLE_11hh/2)*(#mo.silv_telekinesis-1))
		local dist = FixedMul((isvolley() and 64 or 320)*FRACUNIT, mo.scale) / FRACUNIT -- distance (320, or 64 in volley)
		while k
			local v = mo.silv_telekinesis[k]
			if not (v and v.valid and v.health)			-- don't attempt to do anything with those
			or v and v.valid and v.player and P_PlayerInPain(v.player)
			or v and v.valid and R_PointToDist2(v.x, v.y, mo.x, mo.y) > FixedMul(MAX_TELEKINESIS_RANGE, mo.scale)
				silv_resetObject(v)
				table.remove(mo.silv_telekinesis, k)
				k = $-1
				i = $+1
				continue
			end
			v.flags = $|MF_SLIDEME	-- this helps
			local heightfac = 1
			if mo.eflags & MFE_VERTICALFLIP then heightfac = -1 end
			local target_angle, tx, ty, tz
			if not (twod)
				target_angle = baseangle - ANGLE_11hh*(k-1)	-- i hate angulz
				tx, ty = mo.x + dist*FixedMul(cos(target_angle), cos(p.aiming/2)), mo.y + dist*FixedMul(sin(target_angle), cos(p.aiming/2))
				tz = mo.z + (mo.height*heightfac) + dist * sin(p.aiming) + (v.height*heightfac)
			else	-- who the fuck still plays 2d...
				baseangle = ANGLE_11hh/2
				dist = FixedMul(128*FRACUNIT, mo.scale) / FRACUNIT -- lower the dist in 2d
				target_angle = baseangle - ANG1*25*(k-1)	-- i hate angulz
				tx, ty = mo.x + dist*FixedMul(cos(mo.angle), cos(target_angle)), mo.y + dist*FixedMul(sin(mo.angle), cos(target_angle))
				tz = mo.z + (mo.height*heightfac) + dist * sin(target_angle) + (v.height*heightfac)
				v.flags = $|MF_NOCLIPHEIGHT
			end

			if v.type == MT_PLAYER
				v.state = S_PLAY_FALL1
				if v.player
					v.player.normalspeed = 0
					v.player.jumpfactor = 0
					v.player.pflags = $ & ~PF_JUMPED
					v.player.pflags = $ | PF_THOKKED
				end
			end

			v.silv_chase = nil
			v.silv_target = nil	-- make sure those are nil for further instructions...

			local div = v.type == MT_PLAYER and 17 or 12

			v.momx = mo.momx + (tx - v.x) / div
			v.momy = mo.momy + (ty - v.y) / div
			v.momz = mo.momz + (tz - v.z) / div

			v.silv_grab = p		-- last silver player who grabbed us. (this is nil after we touch the ground.)

			local hitbox = P_SpawnMobj(v.x, v.y, v.z, MT_PSYHITBOX)
			hitbox.target = v
			hitbox.radius = v.radius + v.radius/4
			hitbox.height = v.height + v.height/4
			hitbox.tracer = mo
			hitbox.tics = 1
			k = $-1
			i = $+1
			--if (v.player and v.player == lp) and not (camchase) then continue end

			-- get color for overlay depending on selection:
			local clr = SKINCOLOR_TEAL
			if mo.silv_selection > 0
				if mo.silv_selection == (k+1)	-- i-1 because we increment it
				and mo.silv_selectiontimer%20 < 2
				and p == lp
					clr = SKINCOLOR_WHITE
				end
			end

			-- spawn an overlay relative to the camera
			local an = R_PointToAngle(v.x, v.y) + ANGLE_180
			local x, y = v.x + 2*cos(an), v.y + 2*sin(an)
			local overlay = P_SpawnMobj(x, y, v.z, MT_THOK)
			overlay.tics = 1
			overlay.scale = v.scale
			overlay.color = clr
			overlay.frame = $|FF_FULLBRIGHT
			if clr == SKINCOLOR_WHITE then overlay.frame = TR_TRANS20|FF_FULLBRIGHT end
			if v.player and v.player == lp and not camchase
				overlay.flags2 = $|MF2_DONTDRAW
			end

			-- spawn a trail if we're moving...?
			if FixedHypot(v.momx, v.momy) > FRACUNIT*2 or abs(v.momz) > FRACUNIT*2
				local overlay = P_SpawnMobj(v.x, v.y, v.z, MT_THOK)
				overlay.scale = v.scale
				overlay.destscale = v.scale/32
				overlay.scalespeed = v.scale/12
				overlay.clr = SKINCOLOR_TEAL
				overlay.frame = FF_FULLBRIGHT|TR_TRANS70
				if v.player and v.player == lp and not camchase
					overlay.flags2 = $|MF2_DONTDRAW
				end
			end
		end
	end
	-- Manage our thrown objects
	-- Iterate through the table backwards as it is prone to have elements removed from it at any time.
	if mo.silv_thrown and #mo.silv_thrown
		local k = #mo.silv_thrown
		while k

			local v = mo.silv_thrown[k]

			if (not (v and v.valid and v.health)) or (P_IsObjectOnGround(v) and not v.silv_target) or v.silv_grabbed
			and not (v and v.valid and P_CheckDeathPitCollide(v) and v.health)
			or v and v.valid and v.player and P_PlayerInPain(v.player)
				if v and v.valid and not v.silv_grabbed	-- don't reset the object in that case though
					silv_resetObject(v)
				end
				table.remove(mo.silv_thrown, k)
				k = $-1
				continue
			end
			if v.type == MT_PLAYER
				v.state = S_PLAY_PAIN
				if v.player
					v.player.normalspeed = 0
					v.player.jumpfactor = 0
					v.player.pflags = $ & ~PF_JUMPED
					v.player.pflags = $ | PF_THOKKED
				end
			end
			if not (mobjinfo[v.type].flags & MF_SLIDEME)
				v.flags = $ & ~MF_SLIDEME
			end
			if mobjinfo[v.type].flags & MF_MISSILE
				v.flags = $|MF_MISSILE
				v.target = mo
			end
			v.flags = $ & ~MF_MONITOR
			v.flags = $ & ~MF_SHOOTABLE
			v.flags = $|MF_NOCLIPTHING

			-- spawn hitbox (it handles the damagening for us)
			local hitbox = P_SpawnMobj(v.x, v.y, v.z, MT_PSYHITBOX)
			hitbox.target = v
			hitbox.radius = 24*FRACUNIT
			hitbox.height = 48*FRACUNIT
			hitbox.tracer = mo
			hitbox.tics = 1
			hitbox.silv_thrown = true
			v.throwitem = hitbox

			-- follow our target?
			if v.silv_chase
				if v.silv_target and v.silv_target.valid and v.silv_target.health	-- do not attempt to rape a puff of smoke that is the remanents of enemies

					--A_HomingChase crashes on certain conditions... Because? So let's write our own:
					local dist = R_PointToDist2(v.x, v.y, v.silv_target.x, v.silv_target.y) or 1 -- dist shouldn't be 0 or else we're gonna get errors
					v.angle = R_PointToAngle2(v.x, v.y, v.silv_target.x, v.silv_target.y)
					local speedmul = 55*v.scale
					v.momx = FixedMul(FixedDiv(v.silv_target.x - v.x, dist), speedmul)
					v.momy = FixedMul(FixedDiv(v.silv_target.y - v.y, dist), speedmul)
					v.momz = FixedMul(FixedDiv(v.silv_target.z - v.z, dist), speedmul)			-- Merely a copypaste of the C function lmao
				end
				v.silv_chase = $-1
			end

			-- wall detection!
			if silv_blockingWall(v)	-- oof
			or (P_IsObjectOnGround(v) and v.silv_target)
				P_SetObjectMomZ(v, 3*v.scale)
				silv_resetObject(v)
				local hb = P_SpawnMobj(mo.x, mo.y, mo.z, MT_PSYHITBOX)
				hb.wallthrow = true
				hb.fuse = 2
				hb.target = mo
				if v.flags & MF_MONITOR
					P_DamageMobj(v, mo, mo)	-- The monitor will not break otherwise.
				else
					P_DamageMobj(v, hb, mo)	-- It causes oddities otherwise. Man, fuck this game, sometimes.
				end
				silv_fillGauge(mo.player, SILVER_MAX_ENERGY/15)
				table.remove(mo.silv_thrown, k)
				explodeTK(v)
				k = $-1
				continue
			end
			-- spawn trail
			local overlay = P_SpawnMobj(v.x, v.y, v.z, MT_THOK)
			overlay.scale = v.scale
			overlay.destscale = v.scale/32
			overlay.scalespeed = v.scale/12
			overlay.color = SKINCOLOR_TEAL
			overlay.frame = A|FF_FULLBRIGHT|TR_TRANS50
			k = $-1
		end

	end
end)

rawset(_G, "silv_generalPlayerThinker", function(p)	-- we're not actually silver?
	if p and (p.spectator or not p.mo)	-- whatever
		if p.silv_saveskin
			p.normalspeed = skins[p.silv_saveskin].normalspeed
			p.jumpfactor = skins[p.silv_saveskin].jumpfactor	-- avoid having spectators being stuck in an endless limbo
			--R_SetPlayerSkin(p, p.silv_saveskin)
			p.silv_saveskin = nil
		end
	end
	if p and p.mo
		p.silv_saveskin = p.mo.skin	-- this is for spectating
		-- some more thinker for players
		local mo = p.mo
		mo.silv_alivetime = mo.silv_alivetime ~= nil and $+1 or 0	-- used for not throwing stuff as you respawn
		if P_IsObjectOnGround(mo)
			if not mo.silv_ongroundtime then mo.silv_ongroundtime = 0 else mo.silv_ongroundtime = $+1 end
			if mo.silv_ongroundtime >= 2 then mo.silv_grab = nil end	-- reset last grabber
		else
			mo.silv_ongroundtime = nil
		end
	end
	if p and p.mo and (p.mo.skin ~= "silver" or p.charability ~= 69) and p.mo.silv_telekinesis
		p.mo.silv_telekinesis = nil
		p.mo.silv_thrown = nil
		p.mo.silv_energy = nil
		p.mo.silv_usedelay = nil
		p.mo.silv_pusedelay = nil
	end
end)

-- if damaged (or killed), we should drop our items
local function silv_dropobj(mo)
	if mo and mo.silv_telekinesis and #mo.silv_telekinesis and mo.player and mo.player.valid
		silv_droptelekinesis(mo.player)
	end
	-- free ourselves from telekinesis if we got hurt somehow
	if mo.silv_grabbed
		for k,v in ipairs(mo.silv_grab.mo.silv_telekinesis)
			if v == mo
				silv_resetObject(v)
				table.remove(mo.silv_grab.mo.silv_telekinesis, k)
			end
		end
	end
	-- remove ourselves from the thrown table as well if we happen to be in it
	if mo.silv_grab and mo.silv_grab.valid
		for k,v in ipairs(mo.silv_grab.mo.silv_thrown)
			if v == mo
				silv_resetObject(v)
				table.remove(mo.silv_grab.mo.silv_thrown, k)
			end
		end
	end
end
addHook("MobjDamage", silv_dropobj, MT_PLAYER)
addHook("MobjDeath", silv_dropobj, MT_PLAYER)

-- don't damage ourselves or our friends with our held items...
addHook("ShouldDamage", function(mo, e)
	if (e and e.valid and (e.silv_grabbed and e.silv_grab or e.thrownitem and e.thrownitem.valid) and friendlyPlayer(mo.player, e.silv_grab))
		return false
	end
end, MT_PLAYER)

-- make thrown stuff damage stuff.
addHook("MobjMoveCollide", function(mo, e)
	if not mo.silv_thrown then return end
	if e.silv_grabbed then return end
	if e and e.valid and e.flags & MF_SHOOTABLE and e ~= mo.target and e ~= mo.tracer
	and not e.silv_chase and not (e.throwitem and e.throwitem.valid)
		if not (e.type == MT_PLAYER and friendlyPlayer(mo.tracer.player, e.player))
			silv_resetObject(mo.target)
			explodeTK(mo.target)
			for k,v in ipairs(mo.tracer.silv_telekinesis)	-- remove object from the Telekinesis table:
				if v == mo.target
					table.remove(mo.tracer.silv_telekinesis, k)
				end
			end
			mo.tracer.silv_throwcombo = $+1
			local amount = (SILVER_MAX_ENERGY / 8)*mo.tracer.silv_throwcombo
			silv_fillGauge(mo.tracer.player, amount)
			if mo.target and mo.target.kill	-- ngl that's a silly hack to fuck Inazuma over
				P_KillMobj(e, mo.target or mo, mo.tracer or mo)
				if e.player	-- for some reason it doesn't work on its own I don't really get it
					print(e.player.cname.." was decimated by "..mo.tracer.player.cname.."'s deflected Lightning Blast!")
					P_AddPlayerScore(mo.tracer.player, 100)
				end
			else
				P_DamageMobj(e, mo.target or mo, mo.tracer or mo)
			end
			if mo.target and mo.target.valid and e and e.valid
				if mo.target.flags & MF_SHOOTABLE
					P_DamageMobj(mo.target, mo.tracer or mo, mo.tracer or mo)
				else
					P_KillMobj(mo.target)
				end
			end
		end
	end
end, MT_PSYHITBOX)

-- handle held items for some stuff
addHook("MobjThinker", function(h)
	local mo = h.target
	local pmo = h.tracer

	if not pmo or not pmo.valid or pmo.skin ~= "silver"	-- NANI
		silv_resetObject(mo)
	end
end, MT_PSYHITBOX)

-- update telekinesis_table:
local function telk_addonspawn(mo)
	if mo.type == 416 return end
	table.insert(telekinesis_table, mo)
	if mobjinfo[mo.type].flags & MF_MONITOR
		mo.silv_x = mo.x
		mo.silv_y = mo.y
		mo.silv_z = mo.z
	elseif mo.type == MT_PLAYER		-- reset players on spawn.
		silv_resetObject(mo)
	end
end
local function telk_remove(mo)
	if mo.type == 416 return end
	for k,v in ipairs(telekinesis_table)
		if v == mo
			table.remove(telekinesis_table, k)
		end
	end
end
local function telk_resetmonitor(mo)
	if mo.silv_x ~= nil
	and (netgame)
		-- spawn fake monitor...
		local faketv = P_SpawnMobj(mo.x, mo.y, mo.z, MT_MONITOREXPLOSION)
		faketv.fuse = TICRATE*10
		faketv.flags = mo.flags
		faketv.flags2 = mo.flags
		faketv.eflags = mo.eflags
		local fakeicon = P_SpawnMobj(mo.x, mo.y, mo.z, mobjinfo[mo.type].damage)
		fakeicon.flags = mo.flags|MF_NOGRAVITY
		fakeicon.flags2 = mo.flags2
		fakeicon.eflags = mo.eflags
		P_SetObjectMomZ(fakeicon, FRACUNIT*4)
		P_TeleportMove(mo, mo.silv_x, mo.silv_y, mo.silv_z)	-- go back!
	end
end

local function telk_fuckingdetons(mo, inf)	-- this is to avoid game crashing situations between monitors and detons (and situations where players can break monitors thrown at them)
	if inf and inf.type == MT_DETON
		return false
	elseif inf and inf.type == MT_PLAYER and mo.thrownitem and mo.thrownitem.valid
		return false
	end
end

do
	for i = 0, #mobjinfo-1
		if (mobjinfo[i].flags & (MF_ENEMY|MF_BOSS|MF_MONITOR|MF_MISSILE) or i == MT_PLAYER)
		and i ~= MT_CYBRAKDEMON_FLAMESHOT
		and i ~= MT_CYBRAKDEMON_FLAMEREST
		and i ~= MT_FLAMEJETFLAME
		and i ~= MT_FLAMEJETFLAMEB	-- REEE
		and i ~= 416	-- don't do that for seenames helper wtf
		and i ~= MT_SPINFIRE
		or i == MT_GOOP
			addHook("MobjSpawn", telk_addonspawn, i)
			addHook("MobjDeath", telk_remove, i)
			addHook("MobjRemoved", telk_remove, i)
			if mobjinfo[i].flags & MF_MONITOR
				--addHook("MobjDeath", telk_resetmonitor, i)
				addHook("ShouldDamage", telk_fuckingdetons, i)
			end
		end
	end
end

-- Finally, set the hurtmsg for match

local TVname = {
	[MT_SUPERRINGBOX] = "Super Ring Monitor",
	[MT_REDRINGBOX] = "Super Ring Monitor",
	[MT_BLUERINGBOX] = "Super Ring Monitor",
	[MT_SNEAKERTV] = "Super Sneakers Monitor",
	[MT_INV] = "Invincibility Monitor",
	[MT_PRUP] = "1-Up Monitor",
	[MT_YELLOWTV] = "Attraction Shield Monitor",
	[MT_BLUETV] = "Force Shield Monitor",
	[MT_WHITETV] = "Whirlwind Shield Monitor",
	[MT_BLACKTV] = "Armageddon Shield Monitor",
	[MT_GREENTV] = "Elemental Shield Monitor",
	[MT_PITYTV] = "Pity Shield Monitor", 	-- this shouldn't happen technically...
	[MT_EGGMANBOX] = "Eggman Monitor",
	[MT_MIXUPBOX] = "Mix-Up Monitor",
	[MT_RECYCLETV] = "Recycler Monitor",
	[MT_GRAVITYBOX] = "Gravity Boots Monitor",
	[MT_SCORETVSMALL] = "Score Monitor",
	[MT_SCORETVLARGE] = "Score Monitor",
	[MT_QUESTIONBOX] = "Random Monitor"
}

local function isdead(p)
	return (p.health <= 0 and not (p.powers[pw_shield] or p.powers[pw_invulnerability]))
end

rawset(_G, "silv_memeDamage", function(mo, target)

	local memeseed = P_RandomRange(0, 2)
	if not silv_meme() return end

	if target.player
	and skins[target.skin].name:lower():find("sonic")
	and isdead(target.player)
		S_StartSound(mo, sfx_skills)
	else
		S_StartSound(mo, sfx_skill1+memeseed)
	end
end)

local cutname = {
	[WEP_AUTO] = " Automatic ",
	[WEP_BOUNCE] = " Bounce ",
	[WEP_RAIL] = " Rail ",
	[WEP_SCATTER] = " Scatter ",
	[WEP_EXPLODE] = " Explosion ",
	[WEP_GRENADE] = " Grenade ",
}

addHook("HurtMsg", function(p, inflictor, source)
	if not p.mo return end
	if not p.cname return end
	local mo = p.mo

	if not inflictor and mo.silv_grab
		if isdead(p) or P_CheckDeathPitCollide(mo)
			if P_CheckDeathPitCollide(mo)
				P_AddPlayerScore(mo.silv_grab, 50)
			else
				P_AddPlayerScore(mo.silv_grab, 100)
			end
		else
			print(mo.silv_grab.cname.." has thrown "..p.cname.." into some hazard.")
			P_AddPlayerScore(mo.silv_grab, 50)
		end
		silv_memeDamage(mo, p.mo)
		silv_resetObject(mo)
		mo.silv_grab = nil
		return true
	elseif mo.silv_grabbed	-- hurt while held
		if isdead(p)
			if mo.eflags & MFE_UNDERWATER and p.powers[pw_underwater] <= 1
				print(mo.silv_grab.cname.." savagely drowned "..p.cname..".")
				P_AddPlayerScore(mo.silv_grab, 50)
			else
				print(mo.silv_grab.cname.." killed "..p.cname.." by dragging them around.")
			end
			P_AddPlayerScore(mo.silv_grab, 100)
		else
			print(mo.silv_grab.cname.." hurt "..p.cname.." by dragging them around.")
			P_AddPlayerScore(mo.silv_grab, 50)
		end
		silv_memeDamage(mo, p.mo)
		silv_resetObject(mo)
		mo.silv_grab = nil
		return true
	elseif inflictor and inflictor.type == MT_PSYCHOCUT	-- Psychic Knife... thing
		local name = (cutname[inflictor.weapon] or " Psycho ").."Cut "
		if isdead(p)
			print(inflictor.target.player.cname.."'s"..name.."killed "..p.cname..".")
		else
			print(inflictor.target.player.cname.."'s"..name.."hit "..p.cname..".")
		end
		silv_memeDamage(mo, p.mo)
		return true
	elseif inflictor and not (inflictor.flags & MF_MISSILE) and inflictor.throwitem and inflictor.throwitem.valid	-- thrown item hit us

		local line = "'s thrown junk"
		if inflictor.flags & MF_MONITOR
			line = "'s thrown "..(TVname[inflictor.type] or "Monitor")
		elseif inflictor.type == MT_PLAYER
			line = " has thrown "..inflictor.player.cname
		end

		if isdead(p)
			if inflictor.type == MT_PLAYER
				print(inflictor.throwitem.tracer.player.cname..line.." into and killed "..p.cname..".")
			else
				print(inflictor.throwitem.tracer.player.cname..line.." killed "..p.cname..".")
			end
		else
			if inflictor.type == MT_PLAYER
				print(inflictor.throwitem.tracer.player.cname..line.." into and hit "..p.cname..".")
			else
				print(inflictor.throwitem.tracer.player.cname..line.." hit "..p.cname..".")
			end
		end
		silv_memeDamage(mo, p.mo)
		return true
	elseif inflictor and inflictor.valid and inflictor.wallthrow								-- delicious wall pancake
		if isdead(p)
			print(source.player.cname.." turned "..p.cname.." into a pancake.")
		else
			print(source.player.cname.." hit "..p.cname.." against a wall.")
		end
		silv_memeDamage(mo, p.mo)
		return true
	elseif inflictor and inflictor.type == MT_PLAYER and mo.throwitem and mo.throwitem.valid	-- hit by throw recoil
		if isdead(p)
			print(p.cname.." was killed by the recoil after being thrown by "..inflictor.player.cname)
		else
			print(p.cname.." was hit by the recoil after being thrown by "..inflictor.player.cname)
		end
		silv_memeDamage(mo, p.mo)
		return true
	end
end)
